Bug 21565 - SCO checkout confirm should be modal
Summary: SCO checkout confirm should be modal
Status: Pushed to oldstable
Alias: None
Product: Koha
Classification: Unclassified
Component: Self checkout (show other bugs)
Version: master
Hardware: All All
: P5 - low minor (vote)
Assignee: Lucas Gass
QA Contact: Testopia
URL:
Keywords:
Depends on:
Blocks:
 
Reported: 2018-10-12 14:32 UTC by Lucas Gass
Modified: 2020-05-15 18:00 UTC (History)
5 users (show)

See Also:
Change sponsored?: ---
Patch complexity: Small patch
Who signed the patch off:
Text to go in the release notes:
Version(s) released in:
20.05.00, 19.11.06, 19.05.11


Attachments
Bug 21565: Turn SCO receipt promt into modal (3.21 KB, patch)
2019-12-09 17:49 UTC, Lucas Gass
Details | Diff | Splinter Review
Bug 21565: Add modal to SCO confirm (2.77 KB, patch)
2020-04-24 18:40 UTC, Lucas Gass
Details | Diff | Splinter Review
Bug 21565: Add modal to SCO confirm (2.85 KB, patch)
2020-04-29 18:03 UTC, Owen Leonard
Details | Diff | Splinter Review
Bug 21565: (follow-up) Make confirmation buttons more detailed (2.76 KB, patch)
2020-04-29 18:03 UTC, Owen Leonard
Details | Diff | Splinter Review
Bug 21565: (follow-up) Make confirmation buttons more detailed (2.82 KB, patch)
2020-04-29 18:11 UTC, Lucas Gass
Details | Diff | Splinter Review
Bug 21565: (follow-up) Make confirmation buttons more detailed (2.82 KB, patch)
2020-05-02 13:43 UTC, Katrin Fischer
Details | Diff | Splinter Review

Note You need to log in before you can comment on or make changes to this bug.
Description Lucas Gass 2018-10-12 14:32:45 UTC
Upon completion of SCO a user clicks "finish" which invokes a JS alert which says "Would you like to print a receipt?". The options are "Cancel" and "OK". This language is confusing to some patrons who think "Cancel" will cancel the entire SCO transaction. Changing this language to "Yes" and "No" would make it much clearer.
Comment 1 Lucas Gass 2018-12-19 22:03:25 UTC
On further thought, this should probably be changed from a JS alert to something like a jQuery UI dialog box so the text size and other styling can be controlled. JS alerts are too small for some patrons to be able to read.
Comment 2 Maureen Wynkoop 2019-07-12 16:54:59 UTC
I think this would help to make the self-checkout less confusing for customers!
Comment 3 AspenCat Team 2019-09-20 15:49:07 UTC
Several of our libraries have a preference to not have the print receipt pop up at all, if this is changed into a modal, it would be easier to suppress that functionality via jquery
Comment 4 Lucas Gass 2019-12-09 17:49:55 UTC
Created attachment 96107 [details] [review]
Bug 21565: Turn SCO receipt promt into modal

This patch adds a Bootstrap modal to sco-main.tt and updates the javascript in that file to act accordingly.
TEST PLAN:
1. Enable SCO and go to /cgi-bin/koha/sco/sco-main.pl. Make sure SelfCheckReceiptPrompt is set to 'show'
2. Login and click 'Finish' to see the old print alert box.
3. Apply patch and repeat steps 1 and 2.
4. Make sure the modal works for confirming and denying a receipt. Checkout some items and make sure everything still functions the same. 
5. Set SelfCheckReceiptPrompt to 'Don't show' and confirm behavior is acceptable.
Comment 5 Kelly McElligott 2019-12-19 22:20:05 UTC
The print dialog box does not appear in both Firefox and Chrome.  Printing in other areas in the testing sandbox such as print slips works as expected.
Comment 6 Lucas Gass 2020-04-24 18:40:43 UTC
Created attachment 103703 [details] [review]
Bug 21565: Add modal to SCO confirm

This patch uses the confirmModal framework to add a modal confirm to SCO Finish.
TO TEST:
1. Enable SCO and go to /cgi-bin/koha/sco/sco-main.pl. Make sure SelfCheckReceiptPrompt is set to 'show'
2. Login and click 'Finish' to see the old print alert box.
3. Apply patch and repeat steps 1 and 2.
4. Make sure the modal works for confirming and denying a receipt. Checkout some items and make sure everything still functions the same.
5. Make sure when printing a receipt that the print dialog automatally shows
6. Set SelfCheckReceiptPrompt to 'Don't show' and confirm behavior is acceptable.
Comment 7 Owen Leonard 2020-04-29 18:03:47 UTC
Created attachment 103971 [details] [review]
Bug 21565: Add modal to SCO confirm

This patch uses the confirmModal framework to add a modal confirm to
SCO Finish.

TO TEST:

1. Enable SCO and go to /cgi-bin/koha/sco/sco-main.pl. Make sure
   SelfCheckReceiptPrompt is set to 'show'
2. Login and click 'Finish' to see the old print alert box.
3. Apply patch and repeat steps 1 and 2.
4. Make sure the modal works for confirming and denying a receipt.
   Checkout some items and make sure everything still functions the
   same.
5. Make sure when printing a receipt that the print dialog automatally
   shows
6. Set SelfCheckReceiptPrompt to 'Don't show' and confirm behavior is
   acceptable.

Signed-off-by: Owen Leonard <oleonard@myacpl.org>
Comment 8 Owen Leonard 2020-04-29 18:03:51 UTC
Created attachment 103972 [details] [review]
Bug 21565: (follow-up) Make confirmation buttons more detailed

This patch updates the confirmation buttons to be more specific about
what each one does. My concern was that it wasn't clear that "No" meant
"No receipt" and not "Cancel logging out."

The patch also updates the modal confirmation code so that the modal
body is removed if no message is passed for it.

To test, apply the patch and repeat the previous test plan. When you
click "Finish" you should have the options "Print receipt and end
session" and "End session."
Comment 9 Lucas Gass 2020-04-29 18:11:38 UTC
Created attachment 103980 [details] [review]
Bug 21565: (follow-up) Make confirmation buttons more detailed

This patch updates the confirmation buttons to be more specific about
what each one does. My concern was that it wasn't clear that "No" meant
"No receipt" and not "Cancel logging out."

The patch also updates the modal confirmation code so that the modal
body is removed if no message is passed for it.

To test, apply the patch and repeat the previous test plan. When you
click "Finish" you should have the options "Print receipt and end
session" and "End session."

Signed-off-by: Lucas Gass <lucas@bywatersolutions.com>
Comment 10 Katrin Fischer 2020-05-02 13:43:05 UTC
Created attachment 104188 [details] [review]
Bug 21565: (follow-up) Make confirmation buttons more detailed

This patch updates the confirmation buttons to be more specific about
what each one does. My concern was that it wasn't clear that "No" meant
"No receipt" and not "Cancel logging out."

The patch also updates the modal confirmation code so that the modal
body is removed if no message is passed for it.

To test, apply the patch and repeat the previous test plan. When you
click "Finish" you should have the options "Print receipt and end
session" and "End session."

Signed-off-by: Katrin Fischer <katrin.fischer.83@web.de>
Comment 11 Martin Renvoize 2020-05-04 07:54:56 UTC
Nice work everyone!

Pushed to master for 20.05
Comment 12 Joy Nelson 2020-05-11 16:52:58 UTC
Backported to 19.11.x for 19.11.06
Comment 13 Lucas Gass 2020-05-15 18:00:45 UTC
backported to 19.05.x for 19.05.11